package org.jeecg;

import cn.com.ctop.bytedance.service.IReportService;
import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.mapper.CtopOauthTokenMapper;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.common.module.utils.CtopAdConstant;
import cn.com.ctop.common.module.utils.HttpUtils;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouHistoryReportTaskService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaishouInterfaceService;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.ctop.service.IPerformanceSaleService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@RunWith(SpringRunner.class)
@SpringBootTest
@Slf4j
public class SampleTest {
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;


    @Autowired
    private IKuaiShouHistoryReportTaskService reportTaskService;
    @Autowired
    private CtopOauthTokenMapper tokenMapper;


    @Test
    public void kuaisShouReport() {
        try {

            QueryWrapper<CtopOauthToken> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("account_id", 3727345L);
            CtopOauthToken token = tokenMapper.selectOne(queryWrapper);

            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
            Date parse = simpleDateFormat.parse("2020-03-12");
            kuaishouInterfaceService.getAdvertiserReportDaily(token, parse, parse);
        } catch (Exception e) {
            e.printStackTrace();

        }
    }

    @Autowired
    private ICtopOauthTokenService tokenService;
    private static ExecutorService executorService = Executors.newFixedThreadPool(10);
    private static CountDownLatch countDownLatch = null;

    @Test
    public void testLoadJob() {
        List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_BYTEDANCE);
        if (null != tokens && tokens.size() > 0) {
            countDownLatch = new CountDownLatch(tokens.size());
            tokens.forEach(token -> {
                //拉取往期数据
                executorService.submit(new Runnable() {
                    @Override
                    public void run() {
                        try {
                            Date date = new Date();
                            for (int i = 0; i < 180; i++) {
                                Date startDate = DateUtils.addDay(date, -i);
                                reportService.getMaterialReportByPage(token, DateUtils.formatDate(startDate), DateUtils.formatDate(startDate), 1);
                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                        } finally {
                            countDownLatch.countDown();
                        }
                    }
                });
            });
            try {
                countDownLatch.await();
                System.out.println("数据获取完成");
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    @Autowired
    private IReportService reportService;

    @Test
    public void wanHuaTong() {
        String url = "https://ad.oceanengine.com/open_api/2/kaleidoscope/job/smart_cut/submit/";

        JSONObject conditions = new JSONObject();
        conditions.put("advertiser_id", "1659671533108238");
        JSONObject job = new JSONObject();
        job.put("job_conf_id", 10);
        JSONArray input = new JSONArray();
        JSONObject inputJson = new JSONObject();
        inputJson.put("task_id", 1);
        JSONArray videoIds = new JSONArray();
        videoIds.add("v02033aa0000bpspgippskdk4jcuso80");
        inputJson.put("video_ids", videoIds);
        JSONArray music_id = new JSONArray();
        JSONArray image_urls = new JSONArray();
        JSONArray texts = new JSONArray();

        texts.add("哈哈哈哈，这是一个测试文案");
        inputJson.put("texts", texts);

        JSONArray tts = new JSONArray();
        tts.add("true");
        inputJson.put("tts", tts);

        JSONArray video_ratio = new JSONArray();
        video_ratio.add("1");
        inputJson.put("video_ratio", video_ratio);


        JSONArray music_style = new JSONArray();
        music_style.add("1");
        inputJson.put("music_style", music_style);

        JSONArray video_duration = new JSONArray();
        video_duration.add("8");
        inputJson.put("video_duration", video_duration);


        JSONArray speed = new JSONArray();
        speed.add("1.2");
        inputJson.put("speed", speed);

        job.put("input", inputJson);
        job.put("mesg", "测试万花筒");
        conditions.put("job", job);


        JSONObject jsonObject = HttpUtils.bytedancePostRequest("f925c180e05d585f7a9fce048ba62eecc5dab7c2", url, conditions);
        System.err.println(jsonObject);


    }

    @Test
    public void testSalePerformance() {
        performanceSaleService.loadSalsePerformance();
    }

    @Autowired
    private IPerformanceSaleService performanceSaleService;


    @Test
    public void suZhao() {


        Long accountId = 3917130L;
        String token = "0a42e23921e486108105263e75561404";
        kuaishouInterfaceService.getVideoList("e91c778d7de1bd0e9d8f3213d1e0e57c",3820093L, null,null,1);
    }

    @Test
    public void testLoadMatData() {
        CtopOauthToken token = tokenService.getTokenByAccountId(1660215200335886L);
        Date date = new Date();
        //2020-03-20
        for (int i = 0; i < 180; i++) {
            Date startDate = DateUtils.addDay(date, -i);
            reportService.getMaterialReportByPage(token, DateUtils.formatDate(startDate), DateUtils.formatDate(startDate), 1);
        }
//        reportService.getMaterialReportByPage(token, "2020-03-20", "2020-03-20",1);
    }
}
















